# -*- coding: utf-8 -*-
#
# Benötigt werden:
# python
# matplotlib
# numpy
# 
# Die sind im cip-Pool installiert.
#
# Unter Linux-Distributionen mit dem Paketmanager installierbar,
# für Windows gibt es https://www.python.org/download/windows
#
# Mehr Informationen zur Grafik:
# http://matplotlib.org/users/pyplot_tutorial.html
#
# Aufruf dann einfach "python plot_data.py" 
#
# (Wenige) zu plottende Daten können per Hand in eine Datei eingetragen werden.
#
# Bei mehr Daten können diese
# per printf / fprintf in C
# oder cout << ... bzw. in eine Datei per ofstream in C++
# aus dem Programm heraus gespeichert werden
#
import matplotlib.pyplot as plt
import numpy as np

def f(x):
    x = x**2
    return x

left = -1.
right = 1.
x_val = np.linspace(left, right, 5) 
y_val = f(x_val)

# line style
#'-'     solid line style
#'--'    dashed line style
#'-.'    dash-dot line style
#':'     dotted line style

# marker
#'.'     point marker
#','     pixel marker
#'o'     circle marker
#'v'     triangle_down marker
#'^'     triangle_up marker
#'<'     triangle_left marker
#'>'     triangle_right marker
#'s'     square marker
#'p'     pentagon marker
#'*'     star marker

# colour
#‘b’     blue
#‘g’     green
#‘r’     red
#‘c’     cyan
#‘m’     magenta
#‘y’     yellow
#‘k’     black
#‘w’     white

plt.plot(x_val, y_val, '-og', label='f(x)') 
plt.title('plotting example')
plt.legend(loc='upper center')
plt.xlabel('x'); plt.ylabel('f(x)')
plt.grid(True)
plt.show()

filename = 'example.dat'
data = np.loadtxt(filename)

plt.plot(data)
plt.title('2nd plotting example')
plt.xlabel('x'); plt.ylabel('some data')
plt.show()

plt.plot(data[:,1], data[:,0], '--sb')
plt.title('3rd plotting example')
plt.xlabel('x'); plt.ylabel('some data')
plt.show()

plt.semilogx(data[:,1], data[:,0], '--sb')
plt.title('4th plotting example')
plt.xlabel('x'); plt.ylabel('some data')
plt.show()

plt.loglog(data[:,1], data[:,2], '--sb')
plt.title('5th plotting example')
plt.xlabel('x'); plt.ylabel('some data')
plt.show()

plt.plotfile(filename, (0,1), delimiter=' ')
plt.title('6th plotting example')
plt.show()

